#
# spec file for package ninvaders
#
# Copyright (c) 2025 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           ninvaders
Version:        0.1.1
Release:        4.1
Summary:        A space invaders-like game using ncurses
License:        GPL-2.0-or-later
Group:          Amusements/Games/Action/Arcade
URL:            http://ninvaders.sourceforge.net/
Source:         http://downloads.sourceforge.net/ninvaders/%{version}/%{name}-%{version}.tar.gz
# PATCH-FIX-UPSTREAM ninvaders-fix-multiple-definitions.patch -- upstream bug #2
Patch0:         ninvaders-fix-multiple-definitions.patch
# PATCH-FIX-UPSTREAM ninvaders-fix-render-loop.patch -- fix Leap 15+ build error
Patch1:         ninvaders-fix-render-loop.patch
# PATCH-FIX-UPSTREAM ninvaders-obey-cflags.patch -- don't clear pre-set CFLAGS
Patch2:         ninvaders-obey-cflags.patch
# PATCH-FIX-UPSTREAM ninvaders-sighandler_t.patch -- fix gcc15 build
Patch3:         ninvaders-sighandler_t.patch
# PATCH-FIX-UPSTREAM ninvaders-fix-doSleep-decl.patch -- fix gcc15 build
Patch4:         ninvaders-fix-doSleep-decl.patch
BuildRequires:  ncurses-devel

%description
A Space Invaders type game with text-only graphics.

%prep
%autosetup -p1

%build
export CFLAGS="%{optflags} -fcommon"
make %{?_smp_mflags}

%install
install -Dm 0755 nInvaders %{buildroot}%{_bindir}/%{name}

%files
%doc ChangeLog README
%license gpl.txt
%{_bindir}/%{name}

%changelog
* Thu Jul 10 2025 Thomas Zimmermann <tzimmermann@suse.com>
- Backport ninvaders-fix-render-loop.patch: Fix buffer overflow in
  render() function. Same as buffer_owerflow.patch, but with fixed
  patchfile name and updated PATCH-FIX-UPSTREAM.
  Adapted from https://sourceforge.net/p/ninvaders/bugs/2/
- Remove buffer_owerflow.patch: Obsoleted by ninvaders-fix-render-loop.patch.
- Modify ninvaders-obey-cflags.patch: Add missing PATCH-FIX-UPSTREAM comment
  in spec file.
* Thu Jul 10 2025 Thomas Zimmermann <tzimmermann@suse.com>
- Backport ninvaders-fix-multiple-definitions.patch: Fix link-time
  error from multiple definitions of the same symbols in various
  object files.
  Adapted from https://sourceforge.net/p/ninvaders/bugs/2/
- Add ninvaders-sighandler_t.patch: Fix function signature of the
  signal handler. The correct signature expects an integer argument,
  which is currently missing. Resolves compile-time errors.
- Add ninvaders-fix-doSleep-decl.patch: Harmonize conflicting
  declarations of doSleep(). The function expects an integer argument,
  which is currently missing in the declarations. Resolves compile-time
  errors.
- Refresh existing patches accordingly
* Thu Feb 22 2024 Dominique Leuenberger <dimstar@opensuse.org>
- Use %%autosetup macro. Allows to eliminate the usage of deprecated
  %%patchN
* Sun Jun  7 2020 Martin Hauke <mardnh@gmx.de>
- Set CFLAGS+=-fcommon to workaround gcc10 errors (boo#1160244)
* Sun Jan 13 2019 mardnh@gmx.de
- Rename binary from nInvaders to ninvaders
- Add patch:
  * ninvaders-obey-cflags.patch
- Convert inline changelog to ninvaders.changes
- Specfile cleanup
* Mon Dec  3 2018 cwh@suse.de
- Patch buffer owerflow that leads to an build error in Leap 15+
* Wed Jun 23 2004 cwh@suse.de
- initial release
